% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fastrInteropt.R
\name{as.external.float}
\alias{as.external.float}
\title{Marks a R value to be converted to float when passed over to a foreign language.}
\usage{
as.external.float(value)
}
\arguments{
\item{value}{a R value which can be converted to float}
}
\value{
An interop float value. Error in case the given value can't be converted to a float.
}
\description{
Marks a R value to be converted to float when passed over to a foreign language.
}
\examples{
javaFloat <- as.external.float(123)

## used to pass a java float to a java method call
floatClass <- new.java.class('java.lang.Float')
floatClass$valueOf(javaFloat)
}
\seealso{
\code{\link{as.external.byte}}, \code{\link{as.external.char}}, \code{\link{as.external.long}}, \code{\link{as.external.short}}
}
